#pragma once

#include "graphics/model.hpp"
#include "script.hpp"

#include <memory>   // std::unique_ptr
#include <vector>


namespace frog
{


class engine;
struct script;


class game_object
{
    gl::model _model;

    bool destroyed = false;

    std::vector<std::unique_ptr<script>> scripts;

public:
    game_object() = default;

    script* add(std::unique_ptr<script> script);

    bool remove(script* scr);

    void init(engine& engine);

    void stable_update(engine& engine);

    void frame_update(engine& engine);

    void destroy() { destroyed = true; }

    bool is_destroyed() { return destroyed; }

    const gl::model& model() const { return _model; }
          gl::model& model()       { return _model; }
};


} // namespace frog
