#pragma once

#include "scene.hpp"

#include <string>
#include <unordered_map>


namespace frog
{


class engine;


class scene_manager
{
    std::unordered_map<std::string, scene> scenes;

    std::string _current{ };

public:
    scene_manager() = default;

    scene* add(std::string name, scene sc);

    bool remove(const std::string& name);

    bool empty() const { return _current.empty(); }

    void init(engine&);

    void stable_update(engine&);

    void frame_update(engine&);

    void switch_scene(std::string name);

    const scene& current() const { return scenes.at(_current); }
          scene& current()       { return scenes.at(_current); }
};


} // namespace frog

